f-cpu/configuration/opcodes.m4
created Sun Aug 19 17:54:28 2001 by whygee@f-cpu.org
adapted from :
   f-cpu/include/f-cpu_opcodes.h
   created Sat Jul 14 23:26:36 2001 by whygee@f-cpu.org

 -------------------------------------------------------------------------
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 -------------------------------------------------------------------------

********************WARNING!************************
This file contains the definition of the opcode
values, reflecting the most recent work.
All thes values are subject to changes.
They operate on 8-bit values that may be contiguous
(and must, in some cases). The #defines will be
optimized and reorganised later. Don't rely on their
values !!!
****************************************************

check if the necessary files are already processed :
m4_ifdef(`__DEF_OP_FUNCTION_AND',
  `m4_errprint(`
 `__DEF_OP_FUNCTION_AND' is not yet included.
 Please include the necessary file.
')')

  "do nothing" (split from (c)move) :

m4_define(`__DEF_OP_NOP',	`0')

  move and cmove, with the same opcode :

m4_define(`__DEF_OP_MOV',	`1')

  ROP2 uses a 3-bit field in the opcode => 8 opcodes.
  MUX and COMBINE overlap this 8-opcode field, too, but
  only a specific opcode is legal for MUX :

m4_define(`__DEF_OP_ROP2',	`8')
m4_define(`__DEF_OP_MUX',	`__DEF_OP_ROP2')
m4_define(`__DEF_OP_AND',	`(__DEF_OP_OP_ROP2 | __DEF_OP_FUNCTION_AND)')
m4_define(`__DEF_OP_ANDN',	`(__DEF_OP_OP_ROP2 | __DEF_OP_FUNCTION_ANDN)')
m4_define(`__DEF_OP_XOR',	`(__DEF_OP_OP_ROP2 | __DEF_OP_FUNCTION_XOR)')
m4_define(`__DEF_OP_OR',	`(__DEF_OP_OP_ROP2 | __DEF_OP_FUNCTION_OR)')
m4_define(`__DEF_OP_NOR',	`(__DEF_OP_OP_ROP2 | __DEF_OP_FUNCTION_NOR)')
m4_define(`__DEF_OP_XNOR',	`(__DEF_OP_OP_ROP2 | __DEF_OP_FUNCTION_XNOR)')
m4_define(`__DEF_OP_ORN',	`(__DEF_OP_OP_ROP2 | __DEF_OP_FUNCTION_ORN)')
m4_define(`__DEF_OP_NAND',	`(__DEF_OP_OP_ROP2 | __DEF_OP_FUNCTION_NAND)')

  imm8 eats the useful function bits : we can't encode MUX or COMBINE
  with immediate data, MUXI is not possible.

m4_define(`__DEF_OP_ROP2I' ,	`(__DEF_OP_ROP2 | 128)')
m4_define(`__DEF_OP_ANDI'  ,	`(__DEF_OP_OP_ROP2I | __DEF_OP_FUNCTION_AND)')
m4_define(`__DEF_OP_ANDNI' ,	`(__DEF_OP_OP_ROP2I | __DEF_OP_FUNCTION_ANDN)')
m4_define(`__DEF_OP_XORI'  ,	`(__DEF_OP_OP_ROP2I | __DEF_OP_FUNCTION_XOR)')
m4_define(`__DEF_OP_ORI'   ,	`(__DEF_OP_OP_ROP2I | __DEF_OP_FUNCTION_OR)')
m4_define(`__DEF_OP_NORI'  ,	`(__DEF_OP_OP_ROP2I | __DEF_OP_FUNCTION_NOR)')
m4_define(`__DEF_OP_XNORI' ,	`(__DEF_OP_OP_ROP2I | __DEF_OP_FUNCTION_XNOR)')
m4_define(`__DEF_OP_ORNI'  ,	`(__DEF_OP_OP_ROP2I | __DEF_OP_FUNCTION_ORN)')
m4_define(`__DEF_OP_NANDI' ,	`(__DEF_OP_OP_ROP2I | __DEF_OP_FUNCTION_NAND)')

 these 2 opcodes require a 4-bit shift field, but 2 only are
 available from the flag field so we use 2 LSB from the opcode.
 We need 8 opcodes for these 2 :

m4_define(`__DEF_OP_LOADCONS',	`16')
m4_define(`__DEF_OP_LOADCONSX',	`(__DEF_OP_LOADCONS | 4)')
